Bug 501660 - Review Request: mrepo - A tool to set up a yum/apt mirror from various sources
Summary: Review Request: mrepo - A tool to set up a yum/apt mirror from various sources
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Sandro Mathys
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-05-20 08:33 UTC by Susi Lehtola
Modified: 2009-07-21 20:49 UTC (History)
3 users (show)

Fixed In Version: 0.8.6-3.el5
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-07-19 10:11:31 UTC
sandro: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Susi Lehtola 2009-05-20 08:33:18 UTC
Spec URL:
http://theory.physics.helsinki.fi/~jzlehtol/rpms/mrepo.spec

SRPM URL:
http://theory.physics.helsinki.fi/~jzlehtol/rpms/mrepo-0.8.4-2.fc10.src.rpm

Upstream URL: http://dag.wieers.com/home-made/mrepo/

Description:
mrepo builds a local Apt/Yum RPM repository from local ISO files,
downloaded updates and extra packages from RHN and 3rd party
repositories.

It can download all updates and extras automatically, creates
the repository structure and meta-data, enables HTTP access to
the repository and creates a directory-structure for remote
network installations using PXE/TFTP.

mrepo supports ftp, http, sftp, rsync, rhn and other download methods.

With mrepo, you can enable your laptop or a local server to provide
updates for the whole network and provide the proper files to
allow installations via the network.


rpmlint output:
mrepo.noarch: W: obsolete-not-provided yam
mrepo.noarch: E: non-readable /etc/mrepo.conf 0600
mrepo.noarch: W: non-standard-dir-in-var mrepo
mrepo.noarch: W: incoherent-subsys /etc/rc.d/init.d/mrepo $prog
2 packages and 0 specfiles checked; 1 errors, 3 warnings.

These should all be OK.

Comment 1 Sandro Mathys 2009-07-11 23:57:05 UTC
Would you mind updating this to the latest release (0.8.6)? I'm very interested in getting this into Fedora/EPEL. Unfortunately I won't be able to review this (due to lack of experience) but hope to find someone who actually will once this is up-to-date.

Comment 2 Susi Lehtola 2009-07-12 00:08:17 UTC
(In reply to comment #1)
> Would you mind updating this to the latest release (0.8.6)? I'm very interested
> in getting this into Fedora/EPEL.

Done.

http://theory.physics.helsinki.fi/~jzlehtol/rpms/mrepo.spec
http://theory.physics.helsinki.fi/~jzlehtol/rpms/mrepo-0.8.6-1.fc11.src.rpm

> Unfortunately I won't be able to review this
> (due to lack of experience) but hope to find someone who actually will once
> this is up-to-date.  

OK, but you only get experience by doing reviews :)

Comment 3 Sandro Mathys 2009-07-12 09:05:08 UTC
I guess you're right ;) Will do my best to review this.

The spec file you've referenced above is still for the old version, please always upload new spec files together with new srpms.

Comment 4 Sandro Mathys 2009-07-12 09:23:45 UTC
This seems mostly okay, full review below. I used the spec file from the srpm for the review. As soon as you fixed the last bits, I'll approve this.

* MUST: rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint SPECS/mrepo.spec SRPMS/mrepo-0.8.6-1.fc11.src.rpm RPMS/noarch/mrepo-0.8.6-1.fc11.noarch.rpm
mrepo.noarch: W: obsolete-not-provided yam
mrepo.noarch: E: zero-length /usr/share/mrepo/up2date_client/distrotype.py
mrepo.noarch: E: script-without-shebang /usr/share/mrepo/up2date_client/distrotype.py
mrepo.noarch: E: script-without-shebang /usr/share/mrepo/up2date_client/repoBackends/__init__.py
mrepo.noarch: E: non-executable-script /usr/share/mrepo/rhn/SSL.py 0644
mrepo.noarch: E: non-readable /etc/mrepo.conf 0600
mrepo.noarch: E: script-without-shebang /usr/share/mrepo/up2date_client/__init__.py
mrepo.noarch: E: script-without-shebang /usr/share/mrepo/up2date_client/up2dateUtils.py
mrepo.noarch: W: non-standard-dir-in-var mrepo
mrepo.noarch: W: incoherent-subsys /etc/rc.d/init.d/mrepo $prog
2 packages and 1 specfiles checked; 7 errors, 3 warnings.

- There's no yam package to obsolete.
- Why are there empty python files?
- Everything else should be okay.

* MUST: The package must be named according to the Package Naming Guidelines .
* MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
* MUST: The package must meet the Packaging Guidelines.
* MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
* MUST: The License field in the package spec file must match the actual license.
* MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
* MUST: The spec file must be written in American English.
* MUST: The spec file for the package MUST be legible.
* MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
* MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
* MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
* MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
* MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
* MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
* MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
* MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
* MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
* MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
* MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
* MUST: Each package must consistently use macros.

- Please use %{__rm}, %{__perl}, %{__cat} and %{__make}.

* MUST: The package must contain code, or permissable content.
* MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
* MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
* MUST: Header files must be in a -devel package.
* MUST: Static libraries must be in a -static package.
* MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
* MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
* MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
* MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
* MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
* MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
* MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
* MUST: All filenames in rpm packages must be valid UTF-8.
* SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
* SHOULD: The reviewer should test that the package builds in mock.
* SHOULD: The package should compile and build into binary rpms on all supported architectures.
* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.

- In %preun, why is it /service and not /sbin/service?
- In %postun, why does it say <script> instead of mrepo?
- Please don't use once &> and once > plus 2>&1 (%preun and %postun).
- Please keep consistent in how you write things within [ ] (%preun and %postun).

* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Comment 5 Susi Lehtola 2009-07-12 10:14:26 UTC
(In reply to comment #3)
> The spec file you've referenced above is still for the old version, please
> always upload new spec files together with new srpms.  

You probably just didn't refresh your browser.

(In reply to comment #4)
> - There's no yam package to obsolete.

mrepo used to be called yam. The spec is from Dag Wieer's repository. Maybe I can remove the obsolete, since the renamal happened a long time ago.

> - Why are there empty python files?

Good question. I wouldn't remove them, though, since that might break something.

> * MUST: Each package must consistently use macros.
> 
> - Please use %{__rm}, %{__perl}, %{__cat} and %{__make}.

This refers to ($RPM_BUILD_ROOT,$RPM_OPT_FLAGS) vs. (%{buildroot},%{optflags}) - you are not allowed to mix these.

Although using macros for standard commands is not forbidden, IMHO it's bad style: KISS.


> * SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague,
> and left up to the reviewers judgement to determine sanity.
> 
> - In %preun, why is it /service and not /sbin/service?

Good catch.

> - In %postun, why does it say <script> instead of mrepo?

And this :)

> - Please don't use once &> and once > plus 2>&1 (%preun and %postun).

fixes.

> - Please keep consistent in how you write things within [ ] (%preun and
> %postun).

These are straight from https://fedoraproject.org/wiki/Packaging/SysVInitScripts


PS. Please mark the items in the review with OK / N/A / NEEDSWORK.

Comment 7 Sandro Mathys 2009-07-12 16:30:23 UTC
Right, didn't know my browser tends to cache spec files :) Never seems to cache anything else.

Looks like all the important stuff is fixed. Some investigation what's the matter about those empty python files wouldn't be bad I guess. But that can clearly be done later. :)

Thanks for supporting me in my first review! ;)

Will you maintain this package for Fedora and EPEL? If not, I'd be interested in maintaining this for EPEL.

-------------------------------------------------------------
   This package (mrepo) is APPROVED by red (Sandro Mathys)
-------------------------------------------------------------

Comment 8 Susi Lehtola 2009-07-12 16:53:50 UTC
I've thought of doing ir. But I can add you as a comaintainer anyway. 

New Package CVS Request
=======================
Package Name: mrepo
Short Description: A tool to set up a yum/apt mirror from various sources
Owners: jussilehtola red
Branches: EL-4 EL-5 F-10 F-11
InitialCC:

Comment 9 Jason Tibbitts 2009-07-12 17:19:44 UTC
CVS done.

Comment 10 Fedora Update System 2009-07-12 22:16:24 UTC
mrepo-0.8.6-3.el4 has been submitted as an update for Fedora EPEL 4.
http://admin.fedoraproject.org/updates/mrepo-0.8.6-3.el4

Comment 11 Fedora Update System 2009-07-12 22:17:03 UTC
mrepo-0.8.6-3.el5 has been submitted as an update for Fedora EPEL 5.
http://admin.fedoraproject.org/updates/mrepo-0.8.6-3.el5

Comment 12 Fedora Update System 2009-07-12 22:17:34 UTC
mrepo-0.8.6-3.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/mrepo-0.8.6-3.fc10

Comment 13 Fedora Update System 2009-07-12 22:18:09 UTC
mrepo-0.8.6-3.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/mrepo-0.8.6-3.fc11

Comment 14 Fedora Update System 2009-07-13 19:38:59 UTC
mrepo-0.8.6-3.el4 has been pushed to the Fedora EPEL 4 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update mrepo'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-4/FEDORA-EPEL-2009-0055

Comment 15 Fedora Update System 2009-07-13 19:39:34 UTC
mrepo-0.8.6-3.el5 has been pushed to the Fedora EPEL 5 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update mrepo'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/EL-5/FEDORA-EPEL-2009-0071

Comment 16 Fedora Update System 2009-07-19 10:11:25 UTC
mrepo-0.8.6-3.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2009-07-19 10:24:13 UTC
mrepo-0.8.6-3.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2009-07-21 20:48:46 UTC
mrepo-0.8.6-3.el4 has been pushed to the Fedora EPEL 4 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2009-07-21 20:49:02 UTC
mrepo-0.8.6-3.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.